
$(document).ready(function() {

// Set up variables for our makeXdmJsonRequest:

// The servicebase need to be set to the value set in the delivery-server field in <Percussion-root>/rxconfig/DeliveryServer/delivery-servers.xml
var servicebase = "http://your-delivery-server.com";

// Here we set the serviceUrl to the Percussion DTS page API endpoint. Change this to your DTS endpoint URL
var serviceUrl = "http://your-delivery-server/perc-metadata-services/metadata/dated/get";

// The AJAX type is set to "POST"

// Here we can configure a simple AJAX POST payload object for requesting 5 pages orders by most recent publish date.
var payload = {
    "criteria":[
        "type = 'page'"
        // enter additional page parameter values here
   ],
   "maxResults": 5,
   "startIndex": 1
}
// Then we pass in our callback function (which is handleResponse) to either perform logic on success or render and error message
function handleResponse(response) {
    console.log(response.status);
    console.log(response);
    if(response.status == 200){
        // If successfull we can log the response along with a success message.
        console.log(response.data);
        $('#response').text("Response successful. See developer console for output.");
    }
    else{
		// If there is an error then it can be handles here with additional logic
        console.log("AJAX query unsuccessful.");
        console.log("AJAX response code: " + response.status);
    }
    
}

// Call the sampleXdmJsonRequest function passing it a queryString POST payload and our callback function which will run after the AJAX request is completed.  
makeXdmJsonRequest(servicebase, serviceUrl, "POST", handleResponse, payload);

// this is the definition of our makeXdmJsonRequest function. 
function makeXdmJsonRequest(servicebase, url, type, callback, dataObject){
		var self = this;
		
		if(typeof(easyXDM) == 'undefined')
		{
		    // No easyXDM found, attempt to fallback to normal json request
			console.error("easyXDM not defined. Pleae update JavaScript libraries.");
		}
		if(callback == null || typeof(callback) == 'undefined')
		{
		    alert("Callback cannot be null or undefined");
		    return;
		}
		if(!(type == "GET" || type == "POST"))
		{
		    alert("Invalid type specified, must be GET or POST.");
		    return;		    
		}
		if(servicebase == null || typeof(servicebase) == 'undefined'){

            console.error("ServiceBase not defined. Please adjust javascript configuration.");
		}
		var rpc = new easyXDM.Rpc({
	        remote: servicebase + "/perc-common-ui/cors/"
	    },
	    {
	        remote: {
	            request: {}
	        }
	    });
		
		var opts = {
		    url: url,
		    headers: {"Content-Type": "application/json",
			    "Accept": "application/json,text/plain"
			    // "perc-tid":tenantId,
			    // "perc-version":version
			},
		    method: type,
            timeout: 60000
		};
        
		// Add payload object if it exists
		if(dataObject != null && dataObject != '' && typeof(dataObject) != 'undefined')
		{
			opts["data"] = easyXDM.getJSONObject().stringify(dataObject);
		}
		
	    rpc.request(opts, 
	       function(response){ //On Success
	            var isJsonResp = response.headers["Content-Type"] == "application/json";
	    	    var resp = {
	    	       data: isJsonResp ? JSON.parse(response.data) : response.data,
	    	       status: response.status		   
	    	    };
	    	    callback(resp); 
	       }, 
	       function(response){ //On Error
	    	   var resp = {
	    	       message: response.message,
	    	       status: response.status
	    	   };
	    	   callback(resp); 
	      });
	}    // end makeXdmJsonRequest function definition

}); //end document ready 
    